searchNodes=[{"doc":"Fast and flexible runtime type-checking.The main way to use TypeCheck is by adding use TypeCheck in your modules. This will allow you to use the macros of TypeCheck.Macros in your module. It will also bring all functions in TypeCheck.Builtin in scope, which is usually what you want.Using these, you're able to add function-specifications to your functions which will wrap them with runtime type-checks. You'll also be able to create your own type-specifications that can be used in other type- and function-specifications in the same or other modules later on:defmodule User do use TypeCheck defstruct [:name, :age] type age :: non_neg_integer() type t :: %User{name: binary(), age: age()} spec new(binary(), age()) :: t() def new(name, age) do %User{name: name, age: age} end spec is_old_enough?(t(), age()) :: boolean() def is_old_enough?(user, limit) do user.age &gt;= limit end endTypes and their syntaxTypeCheck allows types written using (essentially) the same syntax as Elixir's builtin typespecs. This means the following:literal values like :ok, 10.0 or &quot;my string&quot; desugar to a call to TypeCheck.Builtin.literal/1, which is a type that matches only exactly that value.Basic types like integer(), float(), atom() etc. are directly supported (and exist as functions in TypeCheck.Builtin).tuples of types like {atom(), integer()} are supported (and desugar to TypeCheck.Builtin.fixed_tuple/1)maps where keys are literal values and the values are types like %{a: integer(), b: integer(), 42 =&gt; float()} desugar to calls to TypeCheck.Builtin.fixed_map/1.The same happens with structs like %User{name: binary(), age: non_neg_integer()}sum types like integer() | string() | atom() are supported, and desugar to calls to TypeCheck.Builtin.one_of/1.Ranges like lower..higher are supported, matching integers within the given range. This desugars into a call to TypeCheck.Builtin.range/1.Currently unsupported featuresThe following typespec syntax can not currently be used in TypeCheck. This will hopefully change in future versions of the library.Binary pattern-matches containing size-references like &lt;&lt;_ :: size&gt;&gt;.(Anonymous) function types like ( -&gt; result_type) and (type1, type2 -&gt; result_type).Shorthand nonempty list syntax ([some_type, ...])Literal maps with required(...) and optional(...) keys. (TypeCheck does already support literal maps with a fixed set of keys, as well as maps with any number of key-value-pairs of fixed types. It is the special syntax that might mix these approaches that is not supported yet.)ExtensionsTypeCheck adds the following extensions on Elixir's builtin typespec syntax:fixed-size lists containing types like [1, 2, integer()] are supported, and desugar to TypeCheck.Builtin.fixed_list/1. This example matches only lists of 3 elements where the first element is the literal 1, the second the literal 2 and the last element any integer. Elixir's builtin typespecs do not support fixed-size lists.named types like x :: integer() are supported; these are useful in combination with &quot;type guards&quot; (see the section below).&quot;type guards&quot; using the syntax some_type when arbitrary_code are supported, to add extra arbitrary checks to a value for it to match the type. (See the section about type guards below.)lazy(some_type), which defers type-expansion until during runtime. This is required to be able to expand recursive types. C.f. TypeCheck.Builtin.lazy/1Named Types Type GuardsTo add extra custom checks to a type, you can use a so-called 'type guard'. This is arbitrary code that is executed during a type-check once the type itself already matches.You can use &quot;named types&quot; to refer to (parts of) the value that matched the type, and refer to these from a type-guard:type sorted_pair :: {lower :: number(), higher :: number()} when lower &lt;= higheriex&gt; TypeCheck.conforms!({10, 20}, sorted_pair) {10, 20} iex&gt; TypeCheck.conforms!({20, 10}, sorted_pair) ** (TypeCheck.TypeError) `{20, 10}` does not check against `({lower :: number(), higher :: number()} when lower &lt;= higher)`. Reason: type guard: `lower &lt;= higher` evaluated to false or nil. bound values: %{higher: 10, lower: 20}Named types are available in your guard even from the (both local and remote) types that you are using in your time, as long as those types are not defined as opaque types.Manual type-checkingIf you want to check values against a type outside of the checks the spec macro wraps a function with, you can use the conforms/2/conforms?/2/conforms!/2 macros in this module directly in your code.These are evaluated at compile time which means the resulting checks will be optimized by the compiler. Unfortunately it also means that the types passed to them have to be known at compile time.If you have a type that is constructed dynamically at runtime, you can resort to dynamic_conforms/2 and variants. Because these variants have to evaluate the type-checking code at runtime, these checks are not optimized by the compiler.","ref":"TypeCheck.html","title":"TypeCheck","type":"module"},{"doc":"Makes sure value typechecks the type description type.If it typechecks, we return {:ok, value} Otherwise, we return {:error, %TypeCheck.TypeError{}} which contains information about why the value failed the check.conforms is a macro and expands the type check at compile-time, allowing it to be optimized by the compiler.C.f. TypeCheck.Type.build/1 for more information on what type-expressions are allowed as type parameter.Note: usually you'll want to import TypeCheck.Builtin in the context where you use conforms, which will bring Elixir's builtin types into scope. (Calling use TypeCheck will already do this; see the module documentation of TypeCheck for more information))","ref":"TypeCheck.html#conforms/2","title":"TypeCheck.conforms/2","type":"macro"},{"doc":"Similar to conforms/2, but returns value if the value typechecked and raises TypeCheck.TypeError if it did not.The same features and restrictions apply to this function as to conforms/2.","ref":"TypeCheck.html#conforms!/2","title":"TypeCheck.conforms!/2","type":"macro"},{"doc":"Similar to conforms/2, but returns true if the value typechecked and false if it did not.The same features and restrictions apply to this function as to conforms/2.","ref":"TypeCheck.html#conforms?/2","title":"TypeCheck.conforms?/2","type":"macro"},{"doc":"Makes sure value typechecks the type type. Evaluated at runtime.Because dynamic_conforms/2 is evaluated at runtime:The typecheck cannot be optimized by the compiler, which makes it slower.You must pass an already-expanded type as type. This can be done by using one of your custom types directly (e.g. YourModule.typename()), or by calling TypeCheck.Type.build.Use dynamic_conforms only when you cannot use the normal conforms/2, for instance when you're only able to construct the type to check against at runtime.","ref":"TypeCheck.html#dynamic_conforms/2","title":"TypeCheck.dynamic_conforms/2","type":"function"},{"doc":"Similar to dynamic_conforms/2, but returns value if the value typechecked and raises TypeCheck.TypeError if it did not.The same features and restrictions apply to this function as to dynamic_conforms/2.","ref":"TypeCheck.html#dynamic_conforms!/2","title":"TypeCheck.dynamic_conforms!/2","type":"function"},{"doc":"Similar to dynamic_conforms/2, but returns true if the value typechecked and false if it did not.The same features and restrictions apply to this function as to dynamic_conforms/2.","ref":"TypeCheck.html#dynamic_conforms?/2","title":"TypeCheck.dynamic_conforms?/2","type":"function"},{"doc":"","ref":"TypeCheck.html#t:value/0","title":"TypeCheck.value/0","type":"type"},{"doc":"Contains the spec, type, typep, opaque macros to define runtime-checked function- and type-specifications.UsageThis module is included by calling use TypeCheck. This will set up the module to use the special macros.Avoiding naming conflicts with TypeCheck.BuiltinIf you want to define a type with the same name as one in TypeCheck.Builtin, (which is not particularly recommended), you should hide those particular functions from TypeCheck.Builtin by adding import TypeCheck.Builtin, except: [...] below use TypeCheck manually.","ref":"TypeCheck.Macros.html","title":"TypeCheck.Macros","type":"module"},{"doc":"Define a opaque type specification.This behaves similarly to Elixir's builtin @opaque attribute, and will create a type whose name is public but whose structure is private.Calling this macro will:Fill the @opaque-attribute with a Typespec-friendly representation of the TypeCheck type.Add a (or append to an already existing) @typedoc detailing that the type is managed by TypeCheck, and containing the name of the TypeCheck type. (not the definition, since it is an opaque type).Define a (hidden) public function with the same name (and arity) as the type that returns the TypeCheck.Type as a datastructure when called. This makes the type usable in calls to:definitions of other type-specifications (in the same or different modules).definitions of function-specifications (in the same or different modules).TypeCheck.conforms/2 and variants,TypeCheck.Type.build/1opaque/1 accepts the same typedef expression as type/1.","ref":"TypeCheck.Macros.html#opaque/1","title":"TypeCheck.Macros.opaque/1","type":"macro"},{"doc":"Define a function specification.A function specification will wrap the function with checks that each of its parameters are of the types it expects. as well as checking that the return type is as expected.UsageThe syntax is essentially the same as for built-in @spec attributes:spec function_name(type1, type2) :: return_typeIt is also allowed to introduce named types:spec days_since_epoch(year :: integer, month :: integer, day :: integer) :: integerNote that TypeCheck does not allow the when keyword to be used to restrict the types of recurring type variables (which Elixir's builtin Typespecs allow). This is because:Usually it is more clear to give a recurring type an explicit name.The when keyword is used instead for TypeCheck's type guards'. (See TypeCheck.Builtin.guarded_by/2 for more information.)","ref":"TypeCheck.Macros.html#spec/1","title":"TypeCheck.Macros.spec/1","type":"macro"},{"doc":"Define a public type specification.This behaves similarly to Elixir's builtin @type attribute, and will create a type whose name and definition are public.Calling this macro will:Fill the @type-attribute with a Typespec-friendly representation of the TypeCheck type.Add a (or append to an already existing) @typedoc detailing that the type is managed by TypeCheck, and containing the full definition of the TypeCheck type.Define a (hidden) public function with the same name (and arity) as the type that returns the TypeCheck.Type as a datastructure when called. This makes the type usable in calls to:definitions of other type-specifications (in the same or different modules).definitions of function-specifications (in the same or different modules).TypeCheck.conforms/2 and variants,TypeCheck.Type.build/1UsageThe syntax is essentially the same as for the built-in @type attribute:type type_name :: type_descriptionIt is possible to create parameterized types as well:type dict(key, value) :: [{key, value}]Named typesYou can also introduce named types:type color :: {red :: integer, green :: integer, blue :: integer}Not only is this nice to document that the same type is being used for different purposes, it can also be used with a 'type guard' to add custom checks to your type specifications:type sorted_pair(a, b) :: {first :: a, second :: b} when first &lt;= second","ref":"TypeCheck.Macros.html#type/1","title":"TypeCheck.Macros.type/1","type":"macro"},{"doc":"Define a private type specification.This behaves similarly to Elixir's builtin @typep attribute, and will create a type whose name and structure is private (therefore only usable in the current module).Fill the @typep-attribute with a Typespec-friendly representation of the TypeCheck type.Define a private function with the same name (and arity) as the type that returns the TypeCheck.Type as a datastructure when called. This makes the type usable in calls (in the same module) to:definitions of other type-specificationsdefinitions of function-specificationsTypeCheck.conforms/2 and variants,TypeCheck.Type.build/1typep/1 accepts the same typedef expression as type/1.","ref":"TypeCheck.Macros.html#typep/1","title":"TypeCheck.Macros.typep/1","type":"macro"},{"doc":"","ref":"TypeCheck.Spec.html","title":"TypeCheck.Spec","type":"module"},{"doc":"","ref":"TypeCheck.Spec.html#defined?/3","title":"TypeCheck.Spec.defined?/3","type":"function"},{"doc":"","ref":"TypeCheck.Spec.html#lookup/3","title":"TypeCheck.Spec.lookup/3","type":"function"},{"doc":"","ref":"TypeCheck.Spec.html#lookup!/3","title":"TypeCheck.Spec.lookup!/3","type":"function"},{"doc":"TODO","ref":"TypeCheck.Type.html","title":"TypeCheck.Type","type":"module"},{"doc":"Constructs a concrete type from the given type_ast.This means that you can pass type-syntax to this macro, which will be transformed into explicit calls to the functions in TypeCheck.Builtin.iex&gt; res = TypeCheck.Type.build(:ok | :error) iex&gt; res #TypeCheck.Type&lt; :ok | :error &gt; iex&gt; # This is the same as: iex&gt; import TypeCheck.Builtin, only: [one_of: 2, literal: 1] iex&gt; explicit = one_of(literal(:ok), literal(:error)) iex&gt; res == explicit true iex&gt; res = TypeCheck.Type.build({a :: number(), b :: number()} when a &lt;= b) iex&gt; res #TypeCheck.Type&lt; ({a :: number(), b :: number()} when a &lt;= b) &gt; iex&gt; # This is the same as: iex&gt; import TypeCheck.Builtin, only: [fixed_tuple: 1, number: 0, guarded_by: 2, named_type: 2] iex&gt; explicit = guarded_by(fixed_tuple([named_type(:a, number()), named_type(:b, number())]), quote do a &lt;= b end) iex&gt; explicit #TypeCheck.Type&lt; ({a :: number(), b :: number()} when a &lt;= b) &gt;Of course, you can refer to your own local and remote types as well.","ref":"TypeCheck.Type.html#build/1","title":"TypeCheck.Type.build/1","type":"macro"},{"doc":"","ref":"TypeCheck.Type.html#is_type?/1","title":"TypeCheck.Type.is_type?/1","type":"function"},{"doc":"","ref":"TypeCheck.Type.html#to_typespec/1","title":"TypeCheck.Type.to_typespec/1","type":"macro"},{"doc":"Indicates that we expect a 'type AST' that will be expanded to a proper type. This means that it might contain essentially the full syntax that Elixir Typespecs allow, which will be rewritten to calls to the functions in TypeCheck.Builtin.See TypeCheck.Builtin for the precise syntax you are allowed to use.","ref":"TypeCheck.Type.html#t:expandable_type/0","title":"TypeCheck.Type.expandable_type/0","type":"type"},{"doc":"Something is a TypeCheck.Type if it implements the TypeCheck.Protocols.ToCheck protocol.It is also expected to implement the TypeCheck.Protocols.Inspect protocol (although that has an Any fallback).In practice, this type means 'any of the' structs in the TypeCheck.Builtin.* modules.","ref":"TypeCheck.Type.html#t:t/0","title":"TypeCheck.Type.t/0","type":"type"},{"doc":"Exception to be returned or raised when a value is not of the expected type.This exception has two fields::raw, which will contain the problem tuple of the type check failure.:message, which will contain a the humanly-readable representation of the raw problem_tuple:message is constructed from :raw using the TypeCheck.TypeError.DefaultFormatter. (TODO at some point this might be configured to use your custom formatter instead)","ref":"TypeCheck.TypeError.html","title":"TypeCheck.TypeError","type":"exception"},{"doc":"The name of the particular check. Might be :no_match for simple types, but for more complex types that have multiple checks, it disambugates between them.For instance, for TypeCheck.Builtin.List we have :not_a_list, :different_length, and :element_error.","ref":"TypeCheck.TypeError.html#t:check_name/0","title":"TypeCheck.TypeError.check_name/0","type":"type"},{"doc":"An extra map with any information related to the check that failed.For instance, if the check was a compound check, will contain the field problem: with the child problemtuple as well as :index or :key etc. to indicate _where in the compound structure the check failed.","ref":"TypeCheck.TypeError.html#t:extra_information/0","title":"TypeCheck.TypeError.extra_information/0","type":"type"},{"doc":"A problem_tuple contains all information about a failed type check.","ref":"TypeCheck.TypeError.html#t:problem_tuple/0","title":"TypeCheck.TypeError.problem_tuple/0","type":"type"},{"doc":"The value that was passed in which failed the check.It is included for the easy creation of value did not match y-style messages.","ref":"TypeCheck.TypeError.html#t:problematic_value/0","title":"TypeCheck.TypeError.problematic_value/0","type":"type"},{"doc":"","ref":"TypeCheck.TypeError.html#t:t/0","title":"TypeCheck.TypeError.t/0","type":"type"},{"doc":"Any built-in TypeCheck struct (c.f. TypeCheck.Builtin.*), whose check(s) failed.","ref":"TypeCheck.TypeError.html#t:type_checked_against/0","title":"TypeCheck.TypeError.type_checked_against/0","type":"type"},{"doc":"","ref":"TypeCheck.TypeError.DefaultFormatter.html","title":"TypeCheck.TypeError.DefaultFormatter","type":"module"},{"doc":"Transforms a problem_tuple into a humanly-readable explanation string.C.f. TypeCheck.TypeError.Formatter for more information about problem tuples.","ref":"TypeCheck.TypeError.DefaultFormatter.html#format/1","title":"TypeCheck.TypeError.DefaultFormatter.format/1","type":"function"},{"doc":"","ref":"TypeCheck.TypeError.DefaultFormatter.html#format_wrap/1","title":"TypeCheck.TypeError.DefaultFormatter.format_wrap/1","type":"function"},{"doc":"Behaviour to format your own type errors","ref":"TypeCheck.TypeError.Formatter.html","title":"TypeCheck.TypeError.Formatter","type":"behaviour"},{"doc":"A formatter is expected to turn a problem_tuple into a string that can be used as :message of the TypeCheck.TypeError exception.","ref":"TypeCheck.TypeError.Formatter.html#c:format/1","title":"TypeCheck.TypeError.Formatter.format/1","type":"callback"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:problem_tuple :: TypeCheck.Builtin.Any.problem_tuple() | TypeCheck.Builtin.Atom.problem_tuple() | TypeCheck.Builtin.Binary.problem_tuple() | TypeCheck.Builtin.Bitstring.problem_tuple() | TypeCheck.Builtin.Boolean.problem_tuple() | TypeCheck.Builtin.FixedList.problem_tuple() | TypeCheck.Builtin.FixedMap.problem_tuple() | TypeCheck.Builtin.FixedTuple.problem_tuple() | TypeCheck.Builtin.Float.problem_tuple() | TypeCheck.Builtin.Integer.problem_tuple() | TypeCheck.Builtin.List.problem_tuple() | TypeCheck.Builtin.Literal.problem_tuple() | TypeCheck.Builtin.Map.problem_tuple() | TypeCheck.Builtin.NamedType.problem_tuple() | TypeCheck.Builtin.NegInteger.problem_tuple() | TypeCheck.Builtin.NonNegInteger.problem_tuple() | TypeCheck.Builtin.None.problem_tuple() | TypeCheck.Builtin.Number.problem_tuple() | TypeCheck.Builtin.PosInteger.problem_tuple() | TypeCheck.Builtin.Range.problem_tuple() | TypeCheck.Builtin.Tuple.problem_tuple()","ref":"TypeCheck.TypeError.Formatter.html#t:problem_tuple/0","title":"TypeCheck.TypeError.Formatter.problem_tuple/0","type":"type"},{"doc":"Transforms types to generators.This module is only included when the optional dependency :stream_data is added to your project's dependencies.","ref":"TypeCheck.Type.StreamData.html","title":"TypeCheck.Type.StreamData","type":"module"},{"doc":"","ref":"TypeCheck.Type.StreamData.html#arbitrary_primitive_type_gen/0","title":"TypeCheck.Type.StreamData.arbitrary_primitive_type_gen/0","type":"function"},{"doc":"","ref":"TypeCheck.Type.StreamData.html#arbitrary_type_gen/0","title":"TypeCheck.Type.StreamData.arbitrary_type_gen/0","type":"function"},{"doc":"","ref":"TypeCheck.Type.StreamData.html#fixed_list_gen/0","title":"TypeCheck.Type.StreamData.fixed_list_gen/0","type":"function"},{"doc":"When given a type, it is transformed to a StreamData generator that can be used in a property test.iex&gt; import TypeCheck.Type.StreamData iex&gt; generator = TypeCheck.Type.build({:ok | :error, integer()}) |&gt; to_gen() iex&gt; StreamData.seeded(generator, 42) |&gt; Enum.take(10) [ {:ok, -1}, {:ok, 2}, {:ok, -2}, {:ok, -4}, {:ok, 1}, {:ok, 1}, {:ok, 2}, {:ok, 4}, {:ok, -7}, {:ok, 5} ]","ref":"TypeCheck.Type.StreamData.html#to_gen/1","title":"TypeCheck.Type.StreamData.to_gen/1","type":"function"},{"doc":"Usually you'd want to import this module when you're using TypeCheck. Feel free to import only the things you need, or hide (using import ... except:) the things you don't.","ref":"TypeCheck.Builtin.html","title":"TypeCheck.Builtin","type":"module"},{"doc":"Any Elixir value.Will always succeed.c.f. TypeCheck.Builtin.Anyiex&gt; TypeCheck.conforms!(10, any()) 10 iex&gt; TypeCheck.conforms!(&quot;foobar&quot;, any()) &quot;foobar&quot;","ref":"TypeCheck.Builtin.html#any/0","title":"TypeCheck.Builtin.any/0","type":"function"},{"doc":"Shorthand for range(0..255)","ref":"TypeCheck.Builtin.html#arity/0","title":"TypeCheck.Builtin.arity/0","type":"function"},{"doc":"The same as type, but indicates that the result will be used as a boolean.","ref":"TypeCheck.Builtin.html#as_boolean/1","title":"TypeCheck.Builtin.as_boolean/1","type":"function"},{"doc":"Any Elixir atom.c.f. TypeCheck.Builtin.Atomiex&gt; TypeCheck.conforms!(:ok, atom()) :ok iex&gt; TypeCheck.conforms!(:foo, atom()) :foo iex&gt; TypeCheck.conforms!(10, atom()) ** (TypeCheck.TypeError) `10` is not an atom.","ref":"TypeCheck.Builtin.html#atom/0","title":"TypeCheck.Builtin.atom/0","type":"function"},{"doc":"Any binary.A binary is a bitstring with a bitsize divisible by eight.c.f. TypeCheck.Builtin.Binary","ref":"TypeCheck.Builtin.html#binary/0","title":"TypeCheck.Builtin.binary/0","type":"function"},{"doc":"Any bitstringc.f. TypeCheck.Builtin.Bitstring","ref":"TypeCheck.Builtin.html#bitstring/0","title":"TypeCheck.Builtin.bitstring/0","type":"function"},{"doc":"Any boolean(either true or false.)c.f. TypeCheck.Builtin.Boolean","ref":"TypeCheck.Builtin.html#boolean/0","title":"TypeCheck.Builtin.boolean/0","type":"function"},{"doc":"A byte; shorthand for range(0..255)c.f. range/1","ref":"TypeCheck.Builtin.html#byte/0","title":"TypeCheck.Builtin.byte/0","type":"function"},{"doc":"A char; shorthand for range(0..0x10FFFF)c.f. range/1","ref":"TypeCheck.Builtin.html#char/0","title":"TypeCheck.Builtin.char/0","type":"function"},{"doc":"A list filled with characters; exactly list(char())c.f. list/1 and char/0","ref":"TypeCheck.Builtin.html#charlist/0","title":"TypeCheck.Builtin.charlist/0","type":"function"},{"doc":"A list of fixed size where element_types dictates the types of each of the respective elements.Desugaring of literal lists like [:a, 10, &quot;foo&quot;].Cannot directly be represented in Elixir's builtin Typespecs, and is thus represented as [any()] instead.","ref":"TypeCheck.Builtin.html#fixed_list/1","title":"TypeCheck.Builtin.fixed_list/1","type":"function"},{"doc":"A map with exactly the key-value-pairs indicated by keywordswhere all keys are required to be literal values, and the values are a type specification.Desugaring of literal maps like %{a_key: value_type, &quot;other_key&quot; =&gt; value_type2}.Represented in Elixir's builtin Typespecs as%{required(:a_key) =&gt; value_type1, required(&quot;other key&quot;) =&gt; value_type2}(for e.g. a call to fixed_map([a_key: value_type1, {&quot;other key&quot;, value_type2}]))","ref":"TypeCheck.Builtin.html#fixed_map/1","title":"TypeCheck.Builtin.fixed_map/1","type":"function"},{"doc":"A tuple whose elements are of the types given by list_of_element_types.Desugaring of writing tuples directly in your types: {a, b, c} desugars to fixed_tuple([a, b, c]).Represented in Elixir's builtin Typespecs as a plain tuple, where each of the elements are the respective element of list_of_types.C.f. TypeCheck.Builtin.Tuple","ref":"TypeCheck.Builtin.html#fixed_tuple/1","title":"TypeCheck.Builtin.fixed_tuple/1","type":"function"},{"doc":"Any float.C.f. TypeCheck.Builtin.Float","ref":"TypeCheck.Builtin.html#float/0","title":"TypeCheck.Builtin.float/0","type":"function"},{"doc":"Alias for function/0.","ref":"TypeCheck.Builtin.html#fun/0","title":"TypeCheck.Builtin.fun/0","type":"function"},{"doc":"Any function (of any arity), regardless of input or output typesc.f. TypeCheck.Builtin.Function","ref":"TypeCheck.Builtin.html#function/0","title":"TypeCheck.Builtin.function/0","type":"function"},{"doc":"Adds a 'type guard' to the type, which is an extra check written using arbitrary Elixir code.Desugaring of some_type when guard_code.The type guard is a check written using any Elixir code, which may refer to names set in the type using named_type/2.If this type guard fails (by returning a non-truthy value), the type will not check.For user-friendly error-handling, don't let your type guards throw exceptions.C.f. TypeCheck.Builtin.GuardedCannot be represented in Elixir's builtin Typespecs, and is thus represented as type (without the guard) instead.","ref":"TypeCheck.Builtin.html#guarded_by/2","title":"TypeCheck.Builtin.guarded_by/2","type":"function"},{"doc":"Any integer.C.f. TypeCheck.Builtin.Integer","ref":"TypeCheck.Builtin.html#integer/0","title":"TypeCheck.Builtin.integer/0","type":"function"},{"doc":"Defers type-expansion until the last possible moment.This is used to be able to expand recursive types.For instance, if you have the following:defmodule MyBrokenlist do type empty :: nil type cons(a) :: {a, mylist(a)} type mylist(a) :: empty() | cons(a) spec new_list() :: mylist(any()) def new_list() do nil end spec cons_val(mylist(any()), any()) :: mylist(any) def cons_val(list, val) do {val, list} end endthen when TypeCheck is expanding the specs at compile-time to build the type-checking code, mylist(a) will call cons(a) which will call mylist(a) which will call cons(a) etc. until infinity. This makes compilation hang indefinitely.To be able to handle types like this, use lazy:defmodule MyFixedList do type empty :: nil type cons(a) :: {a, lazy(mylist(a))} type mylist(a) :: empty() | cons(a) spec new_list() :: mylist(any()) def new_list() do nil end spec cons_val(mylist(any()), any()) :: mylist(any) def cons_val(list, val) do {val, list} end endThis will work as intended.Since lazy/1 defers type-expansion (and check-code-generation) until runtime, the compiler is not able to optimize the type-checking code.Thus, you should only use it when necessary, since it will be slower than when using the inner type direcly.In builtin typespecslazy/1 does not exist in Elixir's builtin typespecs (since builtin typespecs does not expand types it does not need to handle recursive types in a special way). Therefore, lazy(some_type) is represented as some_type directly in ELixir's builtin typespecs.","ref":"TypeCheck.Builtin.html#lazy/1","title":"TypeCheck.Builtin.lazy/1","type":"macro"},{"doc":"A (proper) list with any type of elements;shorthand for list(any())C.f. list/1 and any/0","ref":"TypeCheck.Builtin.html#list/0","title":"TypeCheck.Builtin.list/0","type":"function"},{"doc":"A (proper) list containing only elements of type a.C.f. TypeCheck.Builtin.Listiex&gt; TypeCheck.conforms!([1,2,3], list(integer())) [1,2,3] iex&gt; TypeCheck.conforms!(:foo, list(integer())) ** (TypeCheck.TypeError) `:foo` does not check against `list(integer())`. Reason: `:foo` is not a list. iex&gt; TypeCheck.conforms!([1, 2, 3.3], list(integer())) ** (TypeCheck.TypeError) `[1, 2, 3.3]` does not check against `list(integer())`. Reason: at index 2: `3.3` is not an integer.","ref":"TypeCheck.Builtin.html#list/1","title":"TypeCheck.Builtin.list/1","type":"function"},{"doc":"A literal value.Desugaring of using any literal primitive value (like a particular integer, float, atom, binary or bitstring) directly a type.For instance, 10 desugars to literal(10).Represented in Elixir's builtin Typespecs as the primitive value itself.C.f. TypeCheck.Builtin.Literal","ref":"TypeCheck.Builtin.html#literal/1","title":"TypeCheck.Builtin.literal/1","type":"function"},{"doc":"Any Elixir map with any types as keys and any types as values.C.f. TypeCheck.Builtin.Map","ref":"TypeCheck.Builtin.html#map/0","title":"TypeCheck.Builtin.map/0","type":"function"},{"doc":"Any map containing zero or more keys of key_type and values of value_type.Represented in Elixir's builtin Typespecs as %{optional(key_type) =&gt; value_type}.C.f. TypeCheck.Builtin.Map","ref":"TypeCheck.Builtin.html#map/2","title":"TypeCheck.Builtin.map/2","type":"function"},{"doc":"A module-function-arity tupleModule is a module/0function is an atom/0Arity is an arity/0C.f. fixed_tuple/1","ref":"TypeCheck.Builtin.html#mfa/0","title":"TypeCheck.Builtin.mfa/0","type":"function"},{"doc":"Any Elixir atom, but indicates that the atom is expected to be used as a module.c.f. atom/0","ref":"TypeCheck.Builtin.html#module/0","title":"TypeCheck.Builtin.module/0","type":"function"},{"doc":"A type with a local name, which can be referred to from a 'type guard'.This name can be used in 'type guards'. See the module documentation and guarded_by/2 for more information.Desugaring of name :: type (when :: is used inside a type.).Cannot directly be represented in Elixir's builtin Typespecs, and is thus represented as type (without the name) instead.","ref":"TypeCheck.Builtin.html#named_type/2","title":"TypeCheck.Builtin.named_type/2","type":"function"},{"doc":"Any integer smaller than zero.C.f. TypeCheck.Builtin.NegInteger","ref":"TypeCheck.Builtin.html#neg_integer/0","title":"TypeCheck.Builtin.neg_integer/0","type":"function"},{"doc":"See none/0.","ref":"TypeCheck.Builtin.html#no_return/0","title":"TypeCheck.Builtin.no_return/0","type":"function"},{"doc":"Any integer zero or larger.C.f. TypeCheck.Builtin.NonNegInteger","ref":"TypeCheck.Builtin.html#non_neg_integer/0","title":"TypeCheck.Builtin.non_neg_integer/0","type":"function"},{"doc":"Matches no value at all.none() is not very useful on its own, but it is a useful default in certain circumstances, as well as to indicate that you expect some place to not return at all. (instead for instance throwing an exception or looping forever.)C.f. TypeCheck.Builtin.None.","ref":"TypeCheck.Builtin.html#none/0","title":"TypeCheck.Builtin.none/0","type":"function"},{"doc":"Any number (either a float or an integer)Matches the same as integer | float but is more efficient.C.f. TypeCheck.Builtin.Number","ref":"TypeCheck.Builtin.html#number/0","title":"TypeCheck.Builtin.number/0","type":"function"},{"doc":"Version of one_of that allows passing many possibilities at once.A union of multiple types (also known as a 'sum type')Desugaring of types separated by | like a | b or a | b | c | d. (and represented that way in Elixir's builtin Typespecs).c.f. one_of/2.","ref":"TypeCheck.Builtin.html#one_of/1","title":"TypeCheck.Builtin.one_of/1","type":"function"},{"doc":"A union of multiple types (also known as a 'sum type')Desugaring of types separated by | like a | b or a | b | c | d. (and represented that way in Elixir's builtin Typespecs).","ref":"TypeCheck.Builtin.html#one_of/2","title":"TypeCheck.Builtin.one_of/2","type":"function"},{"doc":"Any integer larger than zero.C.f. TypeCheck.Builtin.PosInteger","ref":"TypeCheck.Builtin.html#pos_integer/0","title":"TypeCheck.Builtin.pos_integer/0","type":"function"},{"doc":"Any integer in the half-open range range.Desugaring of a..b. (And represented that way in Elixir's builtin Typespecs.)C.f. TypeCheck.Builtin.Range","ref":"TypeCheck.Builtin.html#range/1","title":"TypeCheck.Builtin.range/1","type":"function"},{"doc":"Any integer between lower (includsive) and higher (exclusive).Desugaring of lower..higher. (And represented that way in Elixir's builtin Typespecs.)C.f. range/1","ref":"TypeCheck.Builtin.html#range/2","title":"TypeCheck.Builtin.range/2","type":"function"},{"doc":"alias for any/0","ref":"TypeCheck.Builtin.html#term/0","title":"TypeCheck.Builtin.term/0","type":"function"},{"doc":"A tuple of any size (with any elements).C.f. TypeCheck.Builtin.Tuple","ref":"TypeCheck.Builtin.html#tuple/0","title":"TypeCheck.Builtin.tuple/0","type":"function"},{"doc":"A tuple whose elements have any types, but which has exactly size elements.Represented in Elixir's builtin Typespecs as a plain tuple, with size elements, where each of the element types is any().For instance, tuple(3) is represented as {any(), any(), any()}.","ref":"TypeCheck.Builtin.html#tuple/1","title":"TypeCheck.Builtin.tuple/1","type":"function"},{"doc":"","ref":"TypeCheck.Builtin.Any.html","title":"TypeCheck.Builtin.Any","type":"module"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:problem_tuple :: none()","ref":"TypeCheck.Builtin.Any.html#t:problem_tuple/0","title":"TypeCheck.Builtin.Any.problem_tuple/0","type":"type"},{"doc":"Checks whether the value is any atom.Returns a problem tuple with the reason :no_match otherwise.","ref":"TypeCheck.Builtin.Atom.html","title":"TypeCheck.Builtin.Atom","type":"module"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:problem_tuple :: {t(), :no_match, map(), any()}","ref":"TypeCheck.Builtin.Atom.html#t:problem_tuple/0","title":"TypeCheck.Builtin.Atom.problem_tuple/0","type":"type"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:t :: %TypeCheck.Builtin.Atom{}","ref":"TypeCheck.Builtin.Atom.html#t:t/0","title":"TypeCheck.Builtin.Atom.t/0","type":"type"},{"doc":"","ref":"TypeCheck.Builtin.Binary.html","title":"TypeCheck.Builtin.Binary","type":"module"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:problem_tuple :: {t(), :no_match, map(), any()}","ref":"TypeCheck.Builtin.Binary.html#t:problem_tuple/0","title":"TypeCheck.Builtin.Binary.problem_tuple/0","type":"type"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:t :: %TypeCheck.Builtin.Binary{}","ref":"TypeCheck.Builtin.Binary.html#t:t/0","title":"TypeCheck.Builtin.Binary.t/0","type":"type"},{"doc":"","ref":"TypeCheck.Builtin.Bitstring.html","title":"TypeCheck.Builtin.Bitstring","type":"module"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:problem_tuple :: {t(), :no_match, map(), any()}","ref":"TypeCheck.Builtin.Bitstring.html#t:problem_tuple/0","title":"TypeCheck.Builtin.Bitstring.problem_tuple/0","type":"type"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:t :: %TypeCheck.Builtin.Bitstring{}","ref":"TypeCheck.Builtin.Bitstring.html#t:t/0","title":"TypeCheck.Builtin.Bitstring.t/0","type":"type"},{"doc":"","ref":"TypeCheck.Builtin.Boolean.html","title":"TypeCheck.Builtin.Boolean","type":"module"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:problem_tuple :: {t(), :no_match, map(), any()}","ref":"TypeCheck.Builtin.Boolean.html#t:problem_tuple/0","title":"TypeCheck.Builtin.Boolean.problem_tuple/0","type":"type"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:t :: %TypeCheck.Builtin.Boolean{}","ref":"TypeCheck.Builtin.Boolean.html#t:t/0","title":"TypeCheck.Builtin.Boolean.t/0","type":"type"},{"doc":"Checks whether the value is a list with the expected elementsOn failure returns a problem tuple with::not_a_list if the value is not a list:different_length if the value is a list but not of equal size.:element_error if one of the elements does not match. The extra information contains in this case :problem and :index to indicate what and where the problem occured.","ref":"TypeCheck.Builtin.FixedList.html","title":"TypeCheck.Builtin.FixedList","type":"module"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:problem_tuple :: {t(), :not_a_list, %{}, any()} | {t(), :different_length, %{expected_length: non_neg_integer()}, list()} | {t(), :element_error, %{problem: lazy(TypeCheck.TypeError.Formatter.problem_tuple()), index: integer()}, list()}","ref":"TypeCheck.Builtin.FixedList.html#t:problem_tuple/0","title":"TypeCheck.Builtin.FixedList.problem_tuple/0","type":"type"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:t :: %TypeCheck.Builtin.FixedList{element_types: list()}","ref":"TypeCheck.Builtin.FixedList.html#t:t/0","title":"TypeCheck.Builtin.FixedList.t/0","type":"type"},{"doc":"Checks whether the value is a list with the expected elementsOn failure returns a problem tuple with::not_a_map if the value is not a map:missing_keys if the value does not have all of the expected keys. The extra information contains in this case :keys with a list of keys that are missing.:value_error if one of the elements does not match. The extra information contains in this case :problem and :key to indicate what and where the problem occured.","ref":"TypeCheck.Builtin.FixedMap.html","title":"TypeCheck.Builtin.FixedMap","type":"module"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:problem_tuple :: {t(), :not_a_map, %{}, any()} | {t(), :missing_keys, %{keys: list(atom())}, map()} | {t(), :value_error, %{problem: lazy(TypeCheck.TypeError.Formatter.problem_tuple()), key: any()}, map()}","ref":"TypeCheck.Builtin.FixedMap.html#t:problem_tuple/0","title":"TypeCheck.Builtin.FixedMap.problem_tuple/0","type":"type"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:t :: %TypeCheck.Builtin.FixedMap{keypairs: list({any(), any()})}","ref":"TypeCheck.Builtin.FixedMap.html#t:t/0","title":"TypeCheck.Builtin.FixedMap.t/0","type":"type"},{"doc":"","ref":"TypeCheck.Builtin.FixedTuple.html","title":"TypeCheck.Builtin.FixedTuple","type":"module"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:problem_tuple :: {t(), :not_a_tuple, %{}, any()} | {t(), :different_size, %{expected_size: integer()}, tuple()} | {t(), :element_error, %{problem: lazy(TypeCheck.TypeError.Formatter.problem_tuple()), index: integer()}, tuple()}","ref":"TypeCheck.Builtin.FixedTuple.html#t:problem_tuple/0","title":"TypeCheck.Builtin.FixedTuple.problem_tuple/0","type":"type"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:t :: %TypeCheck.Builtin.FixedTuple{element_types: list()}","ref":"TypeCheck.Builtin.FixedTuple.html#t:t/0","title":"TypeCheck.Builtin.FixedTuple.t/0","type":"type"},{"doc":"","ref":"TypeCheck.Builtin.Float.html","title":"TypeCheck.Builtin.Float","type":"module"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:problem_tuple :: {t(), :no_match, map(), any()}","ref":"TypeCheck.Builtin.Float.html#t:problem_tuple/0","title":"TypeCheck.Builtin.Float.problem_tuple/0","type":"type"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:t :: %TypeCheck.Builtin.Float{}","ref":"TypeCheck.Builtin.Float.html#t:t/0","title":"TypeCheck.Builtin.Float.t/0","type":"type"},{"doc":"","ref":"TypeCheck.Builtin.Function.html","title":"TypeCheck.Builtin.Function","type":"module"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:problem_tuple :: {t(), :no_match, map(), any()}","ref":"TypeCheck.Builtin.Function.html#t:problem_tuple/0","title":"TypeCheck.Builtin.Function.problem_tuple/0","type":"type"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:t :: %TypeCheck.Builtin.Function{}","ref":"TypeCheck.Builtin.Function.html#t:t/0","title":"TypeCheck.Builtin.Function.t/0","type":"type"},{"doc":"","ref":"TypeCheck.Builtin.Guarded.html","title":"TypeCheck.Builtin.Guarded","type":"module"},{"doc":"","ref":"TypeCheck.Builtin.Integer.html","title":"TypeCheck.Builtin.Integer","type":"module"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:problem_tuple :: {t(), :no_match, map(), any()}","ref":"TypeCheck.Builtin.Integer.html#t:problem_tuple/0","title":"TypeCheck.Builtin.Integer.problem_tuple/0","type":"type"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:t :: %TypeCheck.Builtin.Integer{}","ref":"TypeCheck.Builtin.Integer.html#t:t/0","title":"TypeCheck.Builtin.Integer.t/0","type":"type"},{"doc":"","ref":"TypeCheck.Builtin.Lazy.html","title":"TypeCheck.Builtin.Lazy","type":"module"},{"doc":"","ref":"TypeCheck.Builtin.Lazy.html#lazily_expand_type/1","title":"TypeCheck.Builtin.Lazy.lazily_expand_type/1","type":"function"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:problem_tuple :: lazy(TypeCheck.TypeError.Formatter.problem_tuple())","ref":"TypeCheck.Builtin.Lazy.html#t:problem_tuple/0","title":"TypeCheck.Builtin.Lazy.problem_tuple/0","type":"type"},{"doc":"","ref":"TypeCheck.Builtin.List.html","title":"TypeCheck.Builtin.List","type":"module"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:problem_tuple :: {t(), :not_a_list, %{}, any()} | {t(), :element_error, %{problem: lazy(TypeCheck.TypeError.Formatter.problem_tuple()), index: non_neg_integer()}, any()}","ref":"TypeCheck.Builtin.List.html#t:problem_tuple/0","title":"TypeCheck.Builtin.List.problem_tuple/0","type":"type"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:head (opaque type)","ref":"TypeCheck.Builtin.List.html#t:t/0","title":"TypeCheck.Builtin.List.t/0","type":"opaque"},{"doc":"","ref":"TypeCheck.Builtin.Literal.html","title":"TypeCheck.Builtin.Literal","type":"module"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:problem_tuple :: {t(), :not_same_value, map(), value :: any()}","ref":"TypeCheck.Builtin.Literal.html#t:problem_tuple/0","title":"TypeCheck.Builtin.Literal.problem_tuple/0","type":"type"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:t :: %TypeCheck.Builtin.Literal{value: term()}","ref":"TypeCheck.Builtin.Literal.html#t:t/0","title":"TypeCheck.Builtin.Literal.t/0","type":"type"},{"doc":"","ref":"TypeCheck.Builtin.Map.html","title":"TypeCheck.Builtin.Map","type":"module"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:problem_tuple :: {t(), :not_a_map, %{}, any()} | {t(), :key_error, %{problem: lazy(TypeCheck.TypeError.Formatter.problem_tuple()), key: any()}, any()} | {t(), :value_error, %{problem: lazy(TypeCheck.TypeError.Formatter.problem_tuple()), key: any()}, any()}","ref":"TypeCheck.Builtin.Map.html#t:problem_tuple/0","title":"TypeCheck.Builtin.Map.problem_tuple/0","type":"type"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:head (opaque type)","ref":"TypeCheck.Builtin.Map.html#t:t/0","title":"TypeCheck.Builtin.Map.t/0","type":"opaque"},{"doc":"","ref":"TypeCheck.Builtin.NamedType.html","title":"TypeCheck.Builtin.NamedType","type":"module"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:problem_tuple :: {t(), :named_type, %{problem: lazy(TypeCheck.TypeError.Formatter.problem_tuple())}, any()}","ref":"TypeCheck.Builtin.NamedType.html#t:problem_tuple/0","title":"TypeCheck.Builtin.NamedType.problem_tuple/0","type":"type"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:t :: %TypeCheck.Builtin.NamedType{name: atom(), type: TypeCheck.Type.t()}","ref":"TypeCheck.Builtin.NamedType.html#t:t/0","title":"TypeCheck.Builtin.NamedType.t/0","type":"type"},{"doc":"","ref":"TypeCheck.Builtin.NegInteger.html","title":"TypeCheck.Builtin.NegInteger","type":"module"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:problem_tuple :: {t(), :no_match, map(), any()}","ref":"TypeCheck.Builtin.NegInteger.html#t:problem_tuple/0","title":"TypeCheck.Builtin.NegInteger.problem_tuple/0","type":"type"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:t :: %TypeCheck.Builtin.NegInteger{}","ref":"TypeCheck.Builtin.NegInteger.html#t:t/0","title":"TypeCheck.Builtin.NegInteger.t/0","type":"type"},{"doc":"","ref":"TypeCheck.Builtin.NonNegInteger.html","title":"TypeCheck.Builtin.NonNegInteger","type":"module"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:problem_tuple :: {t(), :no_match, map(), any()}","ref":"TypeCheck.Builtin.NonNegInteger.html#t:problem_tuple/0","title":"TypeCheck.Builtin.NonNegInteger.problem_tuple/0","type":"type"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:t :: %TypeCheck.Builtin.NonNegInteger{}","ref":"TypeCheck.Builtin.NonNegInteger.html#t:t/0","title":"TypeCheck.Builtin.NonNegInteger.t/0","type":"type"},{"doc":"The 'none' type has no inhabitants. In other words, no value will typecheck against this type.This means that we always return a problem tuple with :no_match as reason in its check.It also means that the StreamData-generator will not generate any values; instead, it will filter away values that would have been produced by none(), meaning that if you attempt to use none() directly in a generator, you might get a StreamData.FilterTooNarrowError. However, it's still possible to combine it with other types like :ok | :error | none() and e.g. use the resulting generator of that.","ref":"TypeCheck.Builtin.None.html","title":"TypeCheck.Builtin.None","type":"module"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:problem_tuple :: {t(), :no_match, %{}, val :: any()}","ref":"TypeCheck.Builtin.None.html#t:problem_tuple/0","title":"TypeCheck.Builtin.None.problem_tuple/0","type":"type"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:t :: %TypeCheck.Builtin.None{}","ref":"TypeCheck.Builtin.None.html#t:t/0","title":"TypeCheck.Builtin.None.t/0","type":"type"},{"doc":"","ref":"TypeCheck.Builtin.Number.html","title":"TypeCheck.Builtin.Number","type":"module"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:problem_tuple :: {t(), :no_match, %{}, val :: any()}","ref":"TypeCheck.Builtin.Number.html#t:problem_tuple/0","title":"TypeCheck.Builtin.Number.problem_tuple/0","type":"type"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:t :: %TypeCheck.Builtin.Number{}","ref":"TypeCheck.Builtin.Number.html#t:t/0","title":"TypeCheck.Builtin.Number.t/0","type":"type"},{"doc":"","ref":"TypeCheck.Builtin.OneOf.html","title":"TypeCheck.Builtin.OneOf","type":"module"},{"doc":"","ref":"TypeCheck.Builtin.PosInteger.html","title":"TypeCheck.Builtin.PosInteger","type":"module"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:problem_tuple :: {t(), :no_match, map(), any()}","ref":"TypeCheck.Builtin.PosInteger.html#t:problem_tuple/0","title":"TypeCheck.Builtin.PosInteger.problem_tuple/0","type":"type"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:t :: %TypeCheck.Builtin.PosInteger{}","ref":"TypeCheck.Builtin.PosInteger.html#t:t/0","title":"TypeCheck.Builtin.PosInteger.t/0","type":"type"},{"doc":"","ref":"TypeCheck.Builtin.Range.html","title":"TypeCheck.Builtin.Range","type":"module"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:problem_tuple :: {t(), :not_an_integer, %{}, any()} | {t(), :not_in_range, %{}, integer()}","ref":"TypeCheck.Builtin.Range.html#t:problem_tuple/0","title":"TypeCheck.Builtin.Range.problem_tuple/0","type":"type"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:t :: %TypeCheck.Builtin.Range{range: any()}","ref":"TypeCheck.Builtin.Range.html#t:t/0","title":"TypeCheck.Builtin.Range.t/0","type":"type"},{"doc":"Checks whether the value is any tuple.Returns a problem tuple with the reason :no_match otherwise.","ref":"TypeCheck.Builtin.Tuple.html","title":"TypeCheck.Builtin.Tuple","type":"module"},{"doc":"","ref":"TypeCheck.Builtin.Tuple.html#error_response_type/0","title":"TypeCheck.Builtin.Tuple.error_response_type/0","type":"function"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:problem_tuple :: {t(), :no_match, map(), any()}","ref":"TypeCheck.Builtin.Tuple.html#t:problem_tuple/0","title":"TypeCheck.Builtin.Tuple.problem_tuple/0","type":"type"},{"doc":"This type is managed by TypeCheck, which allows checking values against the type at runtime.Full definition:t :: %TypeCheck.Builtin.Tuple{}","ref":"TypeCheck.Builtin.Tuple.html#t:t/0","title":"TypeCheck.Builtin.Tuple.t/0","type":"type"},{"doc":"","ref":"TypeCheck.Inspect.html","title":"TypeCheck.Inspect","type":"module"},{"doc":"","ref":"TypeCheck.Inspect.html#inspect/2","title":"TypeCheck.Inspect.inspect/2","type":"function"},{"doc":"","ref":"TypeCheck.Inspect.html#inspect_binary/2","title":"TypeCheck.Inspect.inspect_binary/2","type":"function"},{"doc":"","ref":"TypeCheck.Internals.ToTypespec.html","title":"TypeCheck.Internals.ToTypespec","type":"module"},{"doc":"","ref":"TypeCheck.Internals.ToTypespec.html#full_rewrite/2","title":"TypeCheck.Internals.ToTypespec.full_rewrite/2","type":"function"},{"doc":"","ref":"TypeCheck.Internals.ToTypespec.html#rewrite/2","title":"TypeCheck.Internals.ToTypespec.rewrite/2","type":"function"},{"doc":"","ref":"TypeCheck.Protocols.Inspect.html","title":"TypeCheck.Protocols.Inspect","type":"protocol"},{"doc":"","ref":"TypeCheck.Protocols.Inspect.html#inspect/2","title":"TypeCheck.Protocols.Inspect.inspect/2","type":"function"},{"doc":"","ref":"TypeCheck.Protocols.Inspect.html#t:t/0","title":"TypeCheck.Protocols.Inspect.t/0","type":"type"},{"doc":"TypeCheck: Fast and flexible runtime type-checking for your Elixir projects.","ref":"readme.html","title":"TypeCheck: Fast and flexible runtime type-checking for your Elixir projects.","type":"extras"},{"doc":"Type- and function specifications are constructed using (essentially) the same syntax as built-in Elixir Typespecs.When a value does not match a type check, the user is shown human-friendly error messages.Types and type-checks are generated at compiletime.This means type-checking code is optimized rigorously by the compiler.Property-checking generators can be extracted from type specifications without extra work.Flexibility to add custom checks: Subparts of a type can be named, and 'type guards' can be specified to restrict what values are allowed to match that refer to these types.","ref":"readme.html#core-ideas","title":"TypeCheck: Fast and flexible runtime type-checking for your Elixir projects. - Core ideas","type":"extras"},{"doc":"defmodule User do use TypeCheck defstruct [:name, :age] type t :: %User{name: binary, age: integer} end defmodule AgeCheck do use TypeCheck spec is_user_older_than?(User.t, integer) :: boolean def is_user_older_than?(user, age) do user.age &gt;= age end endNow we can try the following:iex&gt; AgeCheck.is_user_older_than?(%User{name: &quot;Qqwy&quot;, age: 11}, 10) true iex&gt; AgeCheck.is_user_older_than?(%User{name: &quot;Qqwy&quot;, age: 9}, 10) falseSo far so good. Now let's see what happens when we pass values that are incorrect:iex&gt; AgeCheck.is_user_older_than?(&quot;foobar&quot;, 42) ** (TypeCheck.TypeError) The call `is_user_older_than?(&quot;foobar&quot;, 42)` does not adhere to spec `is_user_older_than?(%User{age: integer(), name: binary()}, integer()) :: boolean()`. Reason: parameter no. 1: `&quot;foobar&quot;` does not check against `%User{age: integer(), name: binary()}`. Reason: `&quot;foobar&quot;` is not a map. iex&gt; AgeCheck.is_user_older_than?(%User{name: nil, age: 11}, 10) ** (TypeCheck.TypeError) The call `is_user_older_than?(%User{age: 11, name: nil}, 10)` does not adhere to spec `is_user_older_than?(%User{age: integer(), name: binary()}, integer()) :: boolean()`. Reason: parameter no. 1: `%User{age: nil, name: nil}` does not check against `%User{age: integer(), name: binary()}`. Reason: under key `:name`: `nil` is not a binary. iex&gt; AgeCheck.is_user_older_than?(%User{name: &quot;Aaron&quot;, age: nil}, 10) ** (TypeCheck.TypeError) The call `is_user_older_than?(%User{age: nil, name: &quot;Aaron&quot;}, 10)` does not adhere to spec `is_user_older_than?(%User{age: integer(), name: binary()}, integer()) :: boolean()`. Reason: parameter no. 1: `%User{age: nil, name: &quot;Aaron&quot;}` does not check against `%User{age: integer(), name: binary()}`. Reason: under key `:age`: `nil` is not an integer. iex&gt; AgeCheck.is_user_older_than?(%User{name: &quot;José&quot;, age: 11}, 10.0) ** (TypeCheck.TypeError) The call `is_user_older_than?(%User{age: 11, name: &quot;José&quot;}, 10.0)` does not adhere to spec `is_user_older_than?(%User{age: integer(), name: binary()}, integer()) :: boolean()`. Reason: parameter no. 2: `10.0` is not an integer.And if we were to introduce an error in the function definition:defmodule AgeCheck do use TypeCheck spec is_user_older_than?(User.t, integer) :: boolean def is_user_older_than?(user, age) do user.age end endThen we get a nice error message explaining that problem as well:** (TypeCheck.TypeError) The result of calling `is_user_older_than?(%User{age: 26, name: &quot;Marten&quot;}, 10)` does not adhere to spec `is_user_older_than?(%User{age: integer(), name: binary()}, integer()) :: boolean()`. Reason: Returned result: `2` is not a boolean.","ref":"readme.html#usage-example","title":"TypeCheck: Fast and flexible runtime type-checking for your Elixir projects. - Usage Example","type":"extras"},{"doc":"Implemented[x] Proof and implementation of the basic concept[x] Custom type definitions (type, typep, opaque)[x] Basic[x] Parameterized[x] Hide implementation of opaque from documentation[x] Spec argument types checking[x] Spec return type checking[x] Spec possibly named arguments[x] Implementation of Elixir's builtin types[x] Primitive types[x] More primitive types[x] Compound types[x] special forms like |, a..b etc.[x] Literal lists[x] Maps with keys =&gt; types[x] Structs with keys =&gt; types[x] More map/list-based structures.[x] A when to add guards to typedefs for more power.[x] Make errors raised when types do not match humanly readable[x] Improve readability of spec-errors by repeating spec and which parameter did not match.[x] Creating generators from types[x] Don't warn on zero-arity types used without parentheses.[x] Hide structure of opaque and typep from documentation[x] Make sure to handle recursive (and mutually recursive) types without hanging.[x] A compile-error is raised when a type is expanded more than a million times[x] A macro called lazy is introduced to allow to defer type expansion to runtime (to within the check).Pre-stable[ ] Hide named types from opaque types.[ ] Make sure we handle most (if not all) of Typespec's primitive types and syntax.[ ] Overrides for builtin remote types (String.t,Enum.t, Range.t, MapSet.t etc.)[ ] Option to turn @type/@opaque/@typep-injection off for the cases in which it generates improper results.[ ] Configurable setting to turn on/off at compile-time, and maybe dynamically at run-time (with slight performance penalty).[ ] Finalize formatter specification and make a generator for this so that people can easily test their own formatters.[ ] Manually overriding generators for user-specified types if so desired.Longer-term future ideas[ ] Creating generators from specs[ ] Wrap spec-generators so you have a single statement to call in the test suite which will prop-test your function against all allowed inputs/outputs.[ ] Per-module or even per-spec settings to turn on/off, configure formatter, etc.","ref":"readme.html#features-roadmap","title":"TypeCheck: Fast and flexible runtime type-checking for your Elixir projects. - Features &amp; Roadmap","type":"extras"},{"doc":"TypeCheck is available in Hex. The package can be installed by adding type_check to your list of dependencies in mix.exs:def deps do [ {:type_check, &quot;~&gt; 0.1.0&quot;} ] endThe documentation can be found at https://hexdocs.pm/type_check.FormatterTypeCheck exports a couple of macros that you might want to use without parentheses. To make mix format respect this setting, add import_deps: [:type_check] to your .formatter.exs file.","ref":"readme.html#installation","title":"TypeCheck: Fast and flexible runtime type-checking for your Elixir projects. - Installation","type":"extras"},{"doc":"TypeCheck is by no means the other solution out there to reduce the number of bugs in your code.Elixir's builtin typespecs and DialyzerElixir's builtin type-specifications use the same syntax as TypeCheck. They are however not used by the compiler or the runtime, and therefore mainly exist to improve your documentation.Besides documentation, extra external tools like Dialyzer can be used to perform static analysis of the types used in your application.Dialyzer is an opt-in static analysis tool. This means that it can point out some inconsistencies or bugs, but because of its opt-in nature, there are also many problems it cannot detect, and it requires your dependencies to have written all of their typespecs correctly.Dialyzer is also (unfortunately) infamous for its at times difficult-to-understand error messages.An advantage that Dialyzer has over TypeCheck is that its checking is done without having to execute your program code (thus not having any effect on the runtime behaviour or efficiency of your projects).Because TypeCheck adds @type, @typep, @opaque and @spec-attributes based on the types that are defined, it is possible to use Dialyzer together with TypeCheck.NormNorm is an Elixir library for specifying the structure of data that can be used for both validation and data-generation.On a superficial level, Norm and TypeCheck seem similar. However, there are important differences in their design considerations.","ref":"readme.html#typecheck-compared-to-other-tools","title":"TypeCheck: Fast and flexible runtime type-checking for your Elixir projects. - TypeCheck compared to other tools","type":"extras"},{"doc":"yes","ref":"readme.html#is-it-any-good","title":"TypeCheck: Fast and flexible runtime type-checking for your Elixir projects. - Is it any good?","type":"extras"},{"doc":"NormNorm is an Elixir library for specifying the structure of data that can be used for both validation and data-generation.On a superficial level, Norm and TypeCheck seem similar. However, there are important differences in their design considerations:Primary FocusNorm focuses on conforming values to specifications by re-using your existing validations. Norm also has a focus on 'open' schemas that are designed to allow systems to grow over time.TypeCheck focuses on making the types your program is using explicit. This is done by retrofitting Elixir's built-in type syntax to allow you to use a single statement to create (i) a type-/function-specification for in the documentation, (ii) runtime type-checking code and (iii) data-generation for property-testing.SyntaxNorm uses a new, guard-like function-call syntax. Norm is light on the little syntactic sugar: Literal atoms and tuples containing specs as elements are treated as specs themselves. Anything else requires you to write a (dedicated or anonymous) validation function.TypeCheck uses the same syntax that Elixir's built-in typespecs use (and is heavy on the syntactic sugar to make this possible).A couple of syntactical examples:A simple 'manual' validation. (This is common Norm usage but manual validations are more rare in TypeCheck.)# Norm: iex&gt; Norm.conform!(123, spec(is_integer() and &amp;(&amp;1 &gt; 0))) 123# TypeCheck iex&gt; TypeCheck.conforms!(123, non_neg_integer()) # or: iex&gt; TypeCheck.conforms!(123, x :: integer() when x &gt;= 0)Defining custom type-specifications ('specs' in Norm parlance) and function-specifications ('contracts' in Norm parlance):# Norm: defmodule Color do import Norm def rgb(), do: spec(is_integer() and &amp;(&amp;1 in 0..255)) def hex(), do: spec(is_binary() and &amp;String.starts_with?(&amp;1, &quot;#&quot;)) @contract rgb_to_hex(r :: rgb(), g :: rgb(), b :: rgb()) :: hex() def rgb_to_hex(r, g, b) do # ... end end# TypeCheck: defmodule Color do use TypeCheck type rgb :: 0..255 type hex :: (str :: binary() when String.starts_with?(str, &quot;#&quot;)) spec rgb_to_hex(rgb, rgb, rgb) :: hex def rgb_to_hex(r, g, b) do # ... end endDefining a more complicated specification of a custom structure with multiple fields:# Norm: defmodule User do use Norm defstruct [:name, :age] def age_spec(), do: spec(is_integer() and &amp;(&amp;1 &gt;= 0)) def s() do schema(%{ name: spec(is_binary()), age: age_spec(), }) end @contract new(name :: spec(is_binary()), age :: age_spec()) :: s() def new(name, age) do %__MODULE__{name: name, age: age} end @contract ensure_old_enough(user :: s(), limit :: age_spec()) :: alt(success: {:ok, s()}, problem: {:error, spec(is_binary())}) def ensure_old_enough(user, limit) do if user.age &gt;= limit do {:ok, user} else {:error, &quot;not old enough&quot;} end end end# TypeCheck defmodule User do use TypeCheck defstruct [:name, :age] type age :: non_neg_integer() type t :: %User{name: binary(), age: age()} spec new(binary, age) :: t def new(name, age) do %User{name: name, age: age} end spec ensure_old_enough(t, age) :: {:ok, t} | {:error, binary} def ensure_old_enough(user, limit) do if user.age &gt;= limit do {:ok, user} else {:error, &quot;not old enough&quot;} end end endExecutionWhile wrapping functions with a contract happens at compile-time, all contracts and specs are resolved at runtime. This makes Norm's internals less metaprogramming-heavy and allows specs to be created dynamically at runtime, but it does mean that the compiler is not able to optimize the type-checking code.TypeCheck requires (assuming normal usage; escape hatches exist) types to be defined at compile-time and injects the type-checking code to your functions and modules before they are compiled, allowing type-checking to be optimized.DocumentationNorm does not focus on dcumentation. Norm's specs are normal functions which you can document manually using @doc if you wish. Norm's @contracts are not used for documentation purposes.TypeCheck adds @type/@typep/@opaque attributes for the types you specify, making them show up in your documentation and allowing you to use the same type definitions for tools like Dialyzer. You can also use the t helper to look them up in IEx. Documentation can be added to these types by using @typedoc. Function-specifications created with TypeCheck will also add @spec-attributes, which will end up in the documentation of your functions and are similarly useful for e.g. Dialyzer.Data GenerationIt is very useful to generate examples of good data to be used for property testing. Both Norm and TypeCheck have this capability, by using :stream_data as an optional dependency.Norm's generators (only) work when the first predicate in a spec(...) is one of Elixir's built-in guard-clauses. If your spec is too restrictive, you'll have to manually provide a custom data generator as well.TypeCheck builds more complicated generators out of simple ones just as it builds complicated types out of simple ones. This means that virtually all Elixir types can be turned into generators without extra effort of the user. It is only when 'type guards' are used to add arbitrary checks to a type that you might up with a generator that is too restrictive. Currently TypeCheck has no built-in way to customize the generator function, but this is one of the features we'd like to add before a stable release.Error messagesTypeCheck heavily focuses on creating humanly-readable error-messages when a value does not type-check. Norm does not particulary focus on this, (although that might change in the future).Norm and TypeCheck are but two different dots in the datastructure-validation design space. Norm is definitely worth checking out!","ref":"comparing-typecheck-and-norm.html","title":"Comparing TypeCheck and Norm","type":"extras"}]