sidebarNodes={"extras":[{"group":"","headers":[{"anchor":"modules","id":"Modules"}],"id":"api-reference","title":"API Reference"},{"group":"","headers":[{"anchor":"core-ideas","id":"Core ideas"},{"anchor":"usage-example","id":"Usage Example"},{"anchor":"features-roadmap","id":"Features &amp; Roadmap"},{"anchor":"installation","id":"Installation"},{"anchor":"typecheck-compared-to-other-tools","id":"TypeCheck compared to other tools"},{"anchor":"is-it-any-good","id":"Is it any good?"}],"id":"readme","title":"TypeCheck: Fast and flexible runtime type-checking for your Elixir projects."},{"group":"","headers":[],"id":"comparing-typecheck-and-norm","title":"Comparing TypeCheck and Norm"}],"modules":[{"group":"Main","id":"TypeCheck","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:value/0","id":"value/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"conforms/2","id":"conforms/2"},{"anchor":"conforms!/2","id":"conforms!/2"},{"anchor":"conforms?/2","id":"conforms?/2"},{"anchor":"dynamic_conforms/2","id":"dynamic_conforms/2"},{"anchor":"dynamic_conforms!/2","id":"dynamic_conforms!/2"},{"anchor":"dynamic_conforms?/2","id":"dynamic_conforms?/2"}]}],"sections":[{"anchor":"module-types-and-their-syntax","id":"Types and their syntax"},{"anchor":"module-named-types-type-guards","id":"Named Types Type Guards"},{"anchor":"module-manual-type-checking","id":"Manual type-checking"}],"title":"TypeCheck"},{"group":"Main","id":"TypeCheck.Macros","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"opaque/1","id":"opaque/1"},{"anchor":"spec/1","id":"spec/1"},{"anchor":"type/1","id":"type/1"},{"anchor":"typep/1","id":"typep/1"}]}],"sections":[{"anchor":"module-usage","id":"Usage"}],"title":"TypeCheck.Macros"},{"group":"Main","id":"TypeCheck.Spec","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"defined?/3","id":"defined?/3"},{"anchor":"lookup/3","id":"lookup/3"},{"anchor":"lookup!/3","id":"lookup!/3"}]}],"sections":[],"title":"TypeCheck.Spec"},{"group":"Main","id":"TypeCheck.Type","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:expandable_type/0","id":"expandable_type/0"},{"anchor":"t:t/0","id":"t/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"build/1","id":"build/1"},{"anchor":"is_type?/1","id":"is_type?/1"},{"anchor":"to_typespec/1","id":"to_typespec/1"}]}],"sections":[],"title":"TypeCheck.Type"},{"group":"Errors and Formatting them","id":"TypeCheck.TypeError","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:check_name/0","id":"check_name/0"},{"anchor":"t:extra_information/0","id":"extra_information/0"},{"anchor":"t:problem_tuple/0","id":"problem_tuple/0"},{"anchor":"t:problematic_value/0","id":"problematic_value/0"},{"anchor":"t:t/0","id":"t/0"},{"anchor":"t:type_checked_against/0","id":"type_checked_against/0"}]}],"sections":[],"title":"TypeCheck.TypeError"},{"group":"Errors and Formatting them","id":"TypeCheck.TypeError.DefaultFormatter","nested_context":"TypeCheck.TypeError","nested_title":"DefaultFormatter","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"format/1","id":"format/1"},{"anchor":"format_wrap/1","id":"format_wrap/1"}]}],"sections":[],"title":"TypeCheck.TypeError.DefaultFormatter"},{"group":"Errors and Formatting them","id":"TypeCheck.TypeError.Formatter","nested_context":"TypeCheck.TypeError","nested_title":"Formatter","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:problem_tuple/0","id":"problem_tuple/0"}]},{"key":"callbacks","name":"Callbacks","nodes":[{"anchor":"c:format/1","id":"format/1"}]}],"sections":[],"title":"TypeCheck.TypeError.Formatter"},{"group":"Property Testing","id":"TypeCheck.Type.StreamData","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"arbitrary_primitive_type_gen/0","id":"arbitrary_primitive_type_gen/0"},{"anchor":"arbitrary_type_gen/0","id":"arbitrary_type_gen/0"},{"anchor":"fixed_list_gen/0","id":"fixed_list_gen/0"},{"anchor":"to_gen/1","id":"to_gen/1"}]}],"sections":[],"title":"TypeCheck.Type.StreamData"},{"group":"Builtin Types","id":"TypeCheck.Builtin","nodeGroups":[{"key":"built-in-elixir-types","name":"Built-in Elixir types","nodes":[{"anchor":"any/0","id":"any/0"},{"anchor":"arity/0","id":"arity/0"},{"anchor":"as_boolean/1","id":"as_boolean/1"},{"anchor":"atom/0","id":"atom/0"},{"anchor":"binary/0","id":"binary/0"},{"anchor":"bitstring/0","id":"bitstring/0"},{"anchor":"boolean/0","id":"boolean/0"},{"anchor":"byte/0","id":"byte/0"},{"anchor":"char/0","id":"char/0"},{"anchor":"charlist/0","id":"charlist/0"},{"anchor":"fixed_map/1","id":"fixed_map/1"},{"anchor":"fixed_tuple/1","id":"fixed_tuple/1"},{"anchor":"float/0","id":"float/0"},{"anchor":"fun/0","id":"fun/0"},{"anchor":"function/0","id":"function/0"},{"anchor":"integer/0","id":"integer/0"},{"anchor":"list/0","id":"list/0"},{"anchor":"list/1","id":"list/1"},{"anchor":"literal/1","id":"literal/1"},{"anchor":"map/0","id":"map/0"},{"anchor":"mfa/0","id":"mfa/0"},{"anchor":"module/0","id":"module/0"},{"anchor":"neg_integer/0","id":"neg_integer/0"},{"anchor":"no_return/0","id":"no_return/0"},{"anchor":"non_neg_integer/0","id":"non_neg_integer/0"},{"anchor":"none/0","id":"none/0"},{"anchor":"number/0","id":"number/0"},{"anchor":"one_of/1","id":"one_of/1"},{"anchor":"one_of/2","id":"one_of/2"},{"anchor":"pos_integer/0","id":"pos_integer/0"},{"anchor":"range/1","id":"range/1"},{"anchor":"range/2","id":"range/2"},{"anchor":"term/0","id":"term/0"},{"anchor":"tuple/0","id":"tuple/0"}]},{"key":"extensions","name":"Extensions","nodes":[{"anchor":"fixed_list/1","id":"fixed_list/1"},{"anchor":"guarded_by/2","id":"guarded_by/2"},{"anchor":"lazy/1","id":"lazy/1"},{"anchor":"map/2","id":"map/2"},{"anchor":"named_type/2","id":"named_type/2"},{"anchor":"tuple/1","id":"tuple/1"}]}],"sections":[],"title":"TypeCheck.Builtin"},{"group":"Builtin Types","id":"TypeCheck.Builtin.Any","nested_context":"TypeCheck.Builtin","nested_title":"Any","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:problem_tuple/0","id":"problem_tuple/0"}]}],"sections":[],"title":"TypeCheck.Builtin.Any"},{"group":"Builtin Types","id":"TypeCheck.Builtin.Atom","nested_context":"TypeCheck.Builtin","nested_title":"Atom","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:problem_tuple/0","id":"problem_tuple/0"},{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"TypeCheck.Builtin.Atom"},{"group":"Builtin Types","id":"TypeCheck.Builtin.Binary","nested_context":"TypeCheck.Builtin","nested_title":"Binary","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:problem_tuple/0","id":"problem_tuple/0"},{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"TypeCheck.Builtin.Binary"},{"group":"Builtin Types","id":"TypeCheck.Builtin.Bitstring","nested_context":"TypeCheck.Builtin","nested_title":"Bitstring","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:problem_tuple/0","id":"problem_tuple/0"},{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"TypeCheck.Builtin.Bitstring"},{"group":"Builtin Types","id":"TypeCheck.Builtin.Boolean","nested_context":"TypeCheck.Builtin","nested_title":"Boolean","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:problem_tuple/0","id":"problem_tuple/0"},{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"TypeCheck.Builtin.Boolean"},{"group":"Builtin Types","id":"TypeCheck.Builtin.FixedList","nested_context":"TypeCheck.Builtin","nested_title":"FixedList","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:problem_tuple/0","id":"problem_tuple/0"},{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"TypeCheck.Builtin.FixedList"},{"group":"Builtin Types","id":"TypeCheck.Builtin.FixedMap","nested_context":"TypeCheck.Builtin","nested_title":"FixedMap","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:problem_tuple/0","id":"problem_tuple/0"},{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"TypeCheck.Builtin.FixedMap"},{"group":"Builtin Types","id":"TypeCheck.Builtin.FixedTuple","nested_context":"TypeCheck.Builtin","nested_title":"FixedTuple","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:problem_tuple/0","id":"problem_tuple/0"},{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"TypeCheck.Builtin.FixedTuple"},{"group":"Builtin Types","id":"TypeCheck.Builtin.Float","nested_context":"TypeCheck.Builtin","nested_title":"Float","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:problem_tuple/0","id":"problem_tuple/0"},{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"TypeCheck.Builtin.Float"},{"group":"Builtin Types","id":"TypeCheck.Builtin.Function","nested_context":"TypeCheck.Builtin","nested_title":"Function","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:problem_tuple/0","id":"problem_tuple/0"},{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"TypeCheck.Builtin.Function"},{"group":"Builtin Types","id":"TypeCheck.Builtin.Guarded","nested_context":"TypeCheck.Builtin","nested_title":"Guarded","sections":[],"title":"TypeCheck.Builtin.Guarded"},{"group":"Builtin Types","id":"TypeCheck.Builtin.Integer","nested_context":"TypeCheck.Builtin","nested_title":"Integer","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:problem_tuple/0","id":"problem_tuple/0"},{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"TypeCheck.Builtin.Integer"},{"group":"Builtin Types","id":"TypeCheck.Builtin.Lazy","nested_context":"TypeCheck.Builtin","nested_title":"Lazy","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:problem_tuple/0","id":"problem_tuple/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"lazily_expand_type/1","id":"lazily_expand_type/1"}]}],"sections":[],"title":"TypeCheck.Builtin.Lazy"},{"group":"Builtin Types","id":"TypeCheck.Builtin.List","nested_context":"TypeCheck.Builtin","nested_title":"List","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:problem_tuple/0","id":"problem_tuple/0"},{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"TypeCheck.Builtin.List"},{"group":"Builtin Types","id":"TypeCheck.Builtin.Literal","nested_context":"TypeCheck.Builtin","nested_title":"Literal","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:problem_tuple/0","id":"problem_tuple/0"},{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"TypeCheck.Builtin.Literal"},{"group":"Builtin Types","id":"TypeCheck.Builtin.Map","nested_context":"TypeCheck.Builtin","nested_title":"Map","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:problem_tuple/0","id":"problem_tuple/0"},{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"TypeCheck.Builtin.Map"},{"group":"Builtin Types","id":"TypeCheck.Builtin.NamedType","nested_context":"TypeCheck.Builtin","nested_title":"NamedType","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:problem_tuple/0","id":"problem_tuple/0"},{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"TypeCheck.Builtin.NamedType"},{"group":"Builtin Types","id":"TypeCheck.Builtin.NegInteger","nested_context":"TypeCheck.Builtin","nested_title":"NegInteger","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:problem_tuple/0","id":"problem_tuple/0"},{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"TypeCheck.Builtin.NegInteger"},{"group":"Builtin Types","id":"TypeCheck.Builtin.NonNegInteger","nested_context":"TypeCheck.Builtin","nested_title":"NonNegInteger","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:problem_tuple/0","id":"problem_tuple/0"},{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"TypeCheck.Builtin.NonNegInteger"},{"group":"Builtin Types","id":"TypeCheck.Builtin.None","nested_context":"TypeCheck.Builtin","nested_title":"None","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:problem_tuple/0","id":"problem_tuple/0"},{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"TypeCheck.Builtin.None"},{"group":"Builtin Types","id":"TypeCheck.Builtin.Number","nested_context":"TypeCheck.Builtin","nested_title":"Number","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:problem_tuple/0","id":"problem_tuple/0"},{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"TypeCheck.Builtin.Number"},{"group":"Builtin Types","id":"TypeCheck.Builtin.OneOf","nested_context":"TypeCheck.Builtin","nested_title":"OneOf","sections":[],"title":"TypeCheck.Builtin.OneOf"},{"group":"Builtin Types","id":"TypeCheck.Builtin.PosInteger","nested_context":"TypeCheck.Builtin","nested_title":"PosInteger","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:problem_tuple/0","id":"problem_tuple/0"},{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"TypeCheck.Builtin.PosInteger"},{"group":"Builtin Types","id":"TypeCheck.Builtin.Range","nested_context":"TypeCheck.Builtin","nested_title":"Range","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:problem_tuple/0","id":"problem_tuple/0"},{"anchor":"t:t/0","id":"t/0"}]}],"sections":[],"title":"TypeCheck.Builtin.Range"},{"group":"Builtin Types","id":"TypeCheck.Builtin.Tuple","nested_context":"TypeCheck.Builtin","nested_title":"Tuple","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:problem_tuple/0","id":"problem_tuple/0"},{"anchor":"t:t/0","id":"t/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"error_response_type/0","id":"error_response_type/0"}]}],"sections":[],"title":"TypeCheck.Builtin.Tuple"},{"group":"Other","id":"TypeCheck.Inspect","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"inspect/2","id":"inspect/2"},{"anchor":"inspect_binary/2","id":"inspect_binary/2"}]}],"sections":[],"title":"TypeCheck.Inspect"},{"group":"Other","id":"TypeCheck.Internals.ToTypespec","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"full_rewrite/2","id":"full_rewrite/2"},{"anchor":"rewrite/2","id":"rewrite/2"}]}],"sections":[],"title":"TypeCheck.Internals.ToTypespec"},{"group":"Other","id":"TypeCheck.Protocols.Inspect","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"inspect/2","id":"inspect/2"}]}],"sections":[],"title":"TypeCheck.Protocols.Inspect"}],"tasks":[]}